/* export hashed monomial */
static ALGEB export_term(MKernelVector kv, INT32 m)
{
	ALGEB a;
	INT32 *e, i, j;

	e = expon + m;
	for (j=0, i=0; i < nvars; i++) {
		if (e[i]) j++;
	}
	if (j==0) return IMMEDIATE(1);
	a = kv->allocALGEB(2*j+1, MAPLE_PROD);
	for (j=1, i=0; i < nvars; i++) {
		if (!e[i]) continue;
		a[j+0] = A2(vlist[i+1]);
		a[j+1] = A2(IMMEDIATE(e[i]));
		j += 2;
	}
	return a;
}


static ALGEB export_sum(MKernelVector kv, INT32 *r)
{
	ALGEB a;
	M_INT i;

	a = kv->allocALGEB(r[0], MAPLE_SUM);
	for (i=1; i < r[0]; i+=2) {
		a[i+0] = A2(export_term(kv, r[i]));
		a[i+1] = A2(IMMEDIATE(r[i+1]));
	}
	return a;
}


static ALGEB export_dag(MKernelVector kv, INT32 *r)
{
	ALGEB a;
	M_INT n, s, b, d, i, j, m;
	INT32 *e;

	n = nvars;
	s = NUMBITS(n);
	b = BITMASK(s);
	s = FIXSHIFT(s);

	e = expon + r[1];
	d = e[HASH_DEG];
	if (r[0]==3 || d > MAX_IMMEDIATE || (d & b) != d) {
		return export_sum(kv,r);
	}
	a = kv->allocALGEB(r[0]+1, MAPLE_POLY);
	a[1] = A2(vlist);
	for (i=1; i < r[0]; i+=2) {
		e = expon + r[i];
		for (d=m=0, j=0; j < nvars; j++) {
			m = m << s;
			m = m | e[j];
			d = d + e[j];
		}
		m |= d << n*s;
		a[i+1] = A2(m);
		a[i+2] = A2(IMMEDIATE(r[i+1]));
	}
	return a;
}


/* export sequence of dags */
static ALGEB export_seq(MKernelVector kv, INT32 **a)
{
	ALGEB b, c;
	M_INT l, i;

	l = I(a[0]);
	b = kv->allocALGEB(l, MAPLE_EXPSEQ);
	for (i=1; i < l; i++) {
		b[i] = A2(export_dag(kv,a[i]));
	}
	return b;
}
