/* 
	divide by basis (bottom out)
	simplify/F4 search for divisors
	build matrix, map, ref, unmap, find new
	basis is a set of monomials
	mark index when inserting into matrix
	unmark when?

	new basis elements = new rule assigned to monom
*/

typedef struct spoly spoly;
struct spoly {
	INT32 deg;
	INT32 lcm;
	INT32 i;
	INT32 j;
};

static spoly *pairs = NULL;
static INT32  psize = 0;
static INT32  pload = 0;

static INT32 **basis = NULL;
static INT32   bsize = 0;
static INT32   bload = 0;
static const M_INT bfree =  I(1);	/* mark redundant elements */
static const M_INT bmask = ~I(1);	/* mask redundant elements */


static void basis_init()
{
	bsize = 32; bload = 0;
	psize = 96; pload = 0;
	basis = malloc(bsize*sizeof(M_INT));
	pairs = malloc(psize*sizeof(spoly));

	num_reduced = num_useless = num_rowsred = num_zerored = 0;
	select_time = symbol_time = matrix_time = update_time = polmat_time = reduce_time = 0;
	select_cput = symbol_cput = matrix_cput = update_cput = polmat_cput = reduce_cput = 0;
}


static void basis_free()
{
	INT32 *a, i;
	for (i=0; basis && i < bload; i++) {
		a = (INT32 *)((M_INT)basis[i] & bmask);
		free(a);
	}
	if (basis) free(basis);
	if (pairs) free(pairs);
	bsize = bload = psize = pload = 0;
}


/* multiply monomial x polynomial */
static INT32 * poly_scale(INT32 m, INT32 *a)
{
	INT32 *r, i, l;
	r = malloc(a[0]*sizeof(INT32));
	l = r[0] = a[0];
	for (i=1; i < l; i+=2) {
		r[i+0] = monom_mul(m, a[i]);
		r[i+1] = a[i+1];
	}
	return r;
}
