/* integer types */
#if WORDSIZE==64
#define INT32 int
#define INT64 M_INT
#else
#define INT32 M_INT	
#define INT64 long long
#endif

/* Maple */
#define I(x)			(M_INT)(x)
#define UI(x)			(M_UINT)(x)
#define A(x)			((ALGEB)(x))
#define A1(x)			((M_INT *)(x))
#define A2(x)			((M_INT **)(x))
#define IMMEDIATE(x)		A((I(x) << 1) | 1)
#define IS_IMMEDIATE(x)		(I(x) & 1)
#define VALUE_IMMEDIATE(x)	(I(x) >> 1)
#define BITMASK(s)		((~UI(0)) >> (WORDSIZE-(int)(s)))
#define GMP_INT(x)		((mpz_ptr)(A(x)+1))

/* 32 bit */
#if	WORDSIZE==32
#define ID_BITS 6
#define ID(x)     I(UI(x)[0] >> (WORDSIZE-ID_BITS))
#define LENGTH(x) I(UI(x)[0] & ~(~UI(0) << (WORDSIZE-ID_BITS-1)))
const	M_INT MAX_IMMEDIATE = 1073741823;

/* 64 bit */
#elif	WORDSIZE==64
#define ID_BITS 6
#define ID(x)     I((UI(x)[0] >> 32) & ~(~UI(0) << ID_BITS))
#define LENGTH(x)  I(UI(x)[0] & ~(~UI(0) << 31))
const 	M_INT MAX_IMMEDIATE = 4611686018427387903LL;
#endif

/* poly macros */
#define POLY_MAXVAR	(WORDSIZE/2-1)
#define POLY_INDET	1
#define POLY_DEG1	2
#define POLY_COEFF1	3

#define INDETS(p)	A(p[POLY_INDET])
#define NUMVARS(u)	(LENGTH(u)-1)
#define NUMBITS(n)	((n) < 2 ? WORDSIZE : WORDSIZE/(n+1))
#define FIXSHIFT(s)	((s) & (WORDSIZE-1))

#define DEBUG(s,...) do { if (s) printf(__VA_ARGS__); } while (0)
