/* multiple (lcm,basis[i]) */
typedef struct s_row s_row;
struct s_row {
	INT32 lcm;
	INT32 i;
};


/* get minimal pairs */
static INT32 ** select_pairs()
{
	INT32 d, i, j, k, l, m, n;
	INT32 **a, *b;
	s_row *s;

	double c0, c1, t0, t1;
	c0 = cputime(); t0 = realtime();

	/* find minimal degree */
	d = (INT32)1 << 30;
	n = 0;
	for (i=0; i < pload; i++) {
		if (pairs[i].deg > d) ;
		else if (pairs[i].deg == d) n++;
		else d = pairs[i].deg, n=1;
	}
	DEBUG(SYZDB, "select:   %d/%d pairs of degree %d\n", n, pload, d);
	num_reduced += n;

	/* make set of matrix rows */
	s = malloc(2*n*sizeof(s_row));
	for (j=0, i=0; i < pload; i++) {
		if (pairs[i].deg != d) continue;
		s[j].lcm = pairs[i].lcm;
		s[j].i   = pairs[i].i;
		j++;
		s[j].lcm = pairs[i].lcm;
		s[j].i   = pairs[i].j;
		j++;
	}
	n = j;

	/* eliminate duplicates */
	for (i=k=0; i < n; i++) {
		for (j=0; j < k; j++) {
			if (s[i].lcm==s[j].lcm && s[i].i==s[j].i) break;
		}
		if (j==k) s[k++] = s[i];
	}
	DEBUG(SYZDB, "select:   %d row(s) eliminated\n", n-k);
	n = k;

	/* allocate matrix from s-pairs */
	a = malloc((n+1)*sizeof(M_INT));
	a[0] = (INT32 *)I(n+1);

	/* all of the time is here */
	for (i=0; i < n; i++) {
		l = s[i].lcm;
		b = (INT32 *)((M_INT)basis[s[i].i] & bmask);
		m = monom_div(l, b[1]);
		a[i+1] = poly_scale(m, b);
	}
	free(s);

	/* remove s-pairs from set */
	for (i=j=0; i < pload; i++) {
		if (pairs[i].deg == d) continue;
		pairs[j++] = pairs[i];
	}
	pload = j;

	c1 = cputime(); t1 = realtime();
	DEBUG(SYZDB, "select:   %5.3f sec   %5.3f cpu\n", t1-t0, c1-c0);
	select_time += t1-t0;
	select_cput += c1-c0;

	return a;
}
