/* divide monomial by the basis */
static INT32 * symbol_divide(INT32 m)
{
	INT32 *e, *r, *b, q, i;
	e = expon + m;
	i = e[HASH_DIV];
	for (; i < bload; i++) {
		b = (INT32 *)((M_INT)basis[i] & bmask);
		if (b != basis[i]) continue;
		q = monom_div(m, b[1]);
		if (q==0) continue;
		e[HASH_DIV] = i;
		r = poly_scale(q, b);
		return r;
	}
	e[HASH_DIV] = i;
	return NULL;
}


/* symbolic preprocessing */
static INT32 ** symbol_prepro(INT32 **a)
{
	INT32 a0, as, i, j, m, *e, *r, *s;

	double c0, c1, t0, t1;
	c0 = cputime(), t0 = realtime();

	/* mark leading monomials */
	a0 = as = (INT32)(M_INT)a[0];
	for (i=1; i < a0; i++) {
		m = a[i][1];
		e = expon + m;
		e[HASH_IND] = 1;
	}

	/* divide monomials by the basis */
	for (i=1; i < a0; i++) {
		r = a[i];
		for (j=3; j < r[0]; j+=2) {
			m = r[j];
			e = expon + m;
			/* see if already marked */
			if (e[HASH_IND]) continue;
			e[HASH_IND] = 1;
			s = symbol_divide(m);
			if (!s) continue;
			if (a0 == as) {
				as = as*2;
				a = realloc(a, as*sizeof(M_INT));
			}
			a[a0] = s;
			a0++;
		}
	}

	/* clear all markers */
	for (i=1; i < a0; i++) {
		r = a[i];
		for (j=1; j < r[0]; j+=2) {
			m = r[j];
			e = expon + m;
			e[HASH_IND] = 0;
		}
	}

	a = realloc(a, a0*sizeof(M_INT));
	a[0] = (INT32 *)I(a0);

	c1 = cputime(), t1 = realtime();
	DEBUG(SYMDB, "symbol:   %5.3f sec   %5.3f cpu\n", t1-t0, c1-c0);
	symbol_time += t1-t0;
	symbol_cput += c1-c0;

	return a;
}


/* remove polys with reducible leading terms */
/* A should be sorted by increasing monomial */
static INT32 ** symbol_filter(INT32 **A)
{
	INT32 i, j, k, n, *e;

	n = I(A[0]);
	for (i=k=1; i < n; i++) {
		e = expon + A[i][1];
		/* not reducible by basis */
		if (e[HASH_DIV] == bload) {
			A[k++] = A[i];
		}
		else {
			free(A[i]);
		}
	}
	A[0] = (INT32 *)I(k);
	A = realloc(A, k*sizeof(M_INT));
	return A;
}
